"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require("./");
var ERenderer;
(function (ERenderer) {
    ERenderer[ERenderer["test1"] = 0] = "test1";
    ERenderer[ERenderer["test2"] = 1] = "test2";
})(ERenderer || (ERenderer = {}));
const factory = new _1.Factory();
const D = {
    test1: factory.createDecorator(ERenderer.test1),
    test2: factory.createDecorator(ERenderer.test2)
};
describe('form', () => {
    describe('getMetadata', () => {
        it('simple model', () => {
            let Form = class Form extends _1.SForm {
                constructor() {
                    super(...arguments);
                    this.field1 = 'field1';
                    this.field2 = 'field2';
                }
            };
            __decorate([
                D.test1({ name: 'test1' }),
                __metadata("design:type", Object)
            ], Form.prototype, "field1", void 0);
            Form = __decorate([
                D.test2({ name: 'test2' })
            ], Form);
            const form = new _1.FormModel(new Form());
            const meta = _1.getMetadata(form, []);
            expect(meta).not.toBeUndefined();
            expect(meta === null || meta === void 0 ? void 0 : meta.name).toBe('test2');
            const meta2 = _1.getMetadata(form, ['field1']);
            expect(meta2).not.toBeUndefined();
            expect(meta2 === null || meta2 === void 0 ? void 0 : meta2.name).toBe('test1');
            const meta3 = _1.getMetadata(form, ['field2']);
            expect(meta3).toBeUndefined();
        });
        it('tree model', () => {
            let Form2 = class Form2 extends _1.SForm {
                constructor() {
                    super(...arguments);
                    this.field3 = 'field3';
                }
            };
            __decorate([
                D.test2({ name: 'field3' }),
                __metadata("design:type", Object)
            ], Form2.prototype, "field3", void 0);
            Form2 = __decorate([
                D.test2({ name: 'form2' })
            ], Form2);
            class Form extends _1.SForm {
                constructor() {
                    super(...arguments);
                    this.field1 = new Form2();
                    this.field2 = new Form2();
                }
            }
            __decorate([
                D.test1({ name: 'field1' }),
                __metadata("design:type", Object)
            ], Form.prototype, "field1", void 0);
            const form = new _1.FormModel(new Form());
            const meta = _1.getMetadata(form, ['field1']);
            expect(meta).not.toBeUndefined();
            expect(meta === null || meta === void 0 ? void 0 : meta.name).toBe('field1');
            const meta1 = _1.getMetadata(form, ['field2']);
            expect(meta1).not.toBeUndefined();
            expect(meta1 === null || meta1 === void 0 ? void 0 : meta1.name).toBe('form2');
            const meta2 = _1.getMetadata(form, ['field1', 'field3']);
            expect(meta2).not.toBeUndefined();
            expect(meta2 === null || meta2 === void 0 ? void 0 : meta2.name).toBe('field3');
            const meta3 = _1.getMetadata(form, ['field1', 'field3']);
            expect(meta3).not.toBeUndefined();
            expect(meta3 === null || meta3 === void 0 ? void 0 : meta3.name).toBe('field3');
        });
    });
});
//# sourceMappingURL=form.spec.js.map