"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const proto_1 = require("./proto");
const meta_1 = require("./meta");
const getInputName$ = (proto, realPath, parentFormName, i = 0) => {
    var _a;
    const protoForm = proto_1.getProtoForm(proto);
    // get form name only for top item
    const formName = (i === 0 && !parentFormName ? (_a = meta_1.getMetadataForm(protoForm)) === null || _a === void 0 ? void 0 : _a.name : '') || '';
    if (realPath.length === 0) {
        return [formName];
    }
    const propsName = realPath[i];
    const fieldMeta = meta_1.getMetadataField(proto, propsName);
    const nextProto = proto_1.getSubProto(proto, propsName);
    const result = [parentFormName, formName, (fieldMeta === null || fieldMeta === void 0 ? void 0 : fieldMeta.name) || propsName];
    if (!nextProto) {
        return result;
    }
    else {
        const tailResult = getInputName$(nextProto, realPath, parentFormName, i + 1);
        return result.concat(tailResult);
    }
};
exports.join = (names) => names.filter(p => p).join('.');
exports.getInputName = (proto, realPath, parentFormName) => exports.join(getInputName$(proto, realPath, parentFormName));
//# sourceMappingURL=helpers.js.map