import 'reflect-metadata';
import { IMetaProps, Renderers, IFieldProps } from './types';
import { $Proto, $ProtoForm } from './proto';
export declare const getMetadataField: <T = {}>(proto: $Proto, propName: string) => (Partial<IFieldProps> & T) | undefined;
export declare const getMetadataForm: <T = {}>(proto: $ProtoForm) => (T & Partial<IFieldProps>) | undefined;
declare type TDecorator<TInterface> = (_: Partial<IFieldProps> & Omit<TInterface, 'type'>) => {
    (target: Function): void;
    (target: Object, propertyKey: string | symbol): void;
};
export declare class Factory<TType$> {
    createDecorator<TType extends TType$, TInterface>(ttype: TType): TDecorator<TInterface> & {
        $$type: {
            type: TType;
        } & TInterface;
    };
    createRender<T>(reconsiler: (props: IMetaProps<TType$>) => Renderers<T>, props: IMetaProps<TType$>): Renderers<T>;
}
export {};
