import { Touched, SForm } from './types';
export declare abstract class Validation<TForm, TInstance> {
    protected form: TForm;
    constructor(form: TForm);
    protected abstract getTouched(instance: TInstance): Touched<TForm>;
    protected abstract getErrorMessage(value: any, path: string[]): string | undefined;
    isTouched(path: string[]): boolean;
    getError(val: any, path: string[]): string | undefined;
    protected getFieldMetadata<TForm extends SForm, TMeta>(form: TForm, path: string[]): (Partial<import("./types").IFieldProps> & TMeta) | undefined;
}
