"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const proto_1 = require("./proto");
const meta_1 = require("./meta");
const get_1 = __importDefault(require("lodash/get"));
class Validation {
    constructor(form) {
        this.form = form;
    }
    isTouched(path) {
        const touched = this.getTouched(this);
        return !!get_1.default(touched, path);
    }
    getError(val, path) {
        const isTouched = this.isTouched(path);
        return isTouched ? this.getErrorMessage(val, path) : undefined;
    }
    getFieldMetadata(form, path) {
        const proto = proto_1.getProto(form, path);
        if (!proto) {
            return;
        }
        const propName = path.length ? path[path.length - 1] : undefined;
        return propName
            ? meta_1.getMetadataField(proto, propName)
            : meta_1.getMetadataForm(proto_1.getProtoForm(proto));
    }
}
exports.Validation = Validation;
//# sourceMappingURL=validation.js.map